/***************************************************************
 * Name:      PE5004_GUI.cpp
 * Purpose:   Code for Application Frame
 * Author:    jvc ()
 * Created:   2010-11-15
 * Copyright: jvc ()
 * License:
 **************************************************************/


#include "5004_GUI.h"

#include <iostream>
#include <fstream>
#include <wx/wx.h>
#include "windows.h"
#include "version.h"
#include "wxDialogs.h"
#include "wx/config.h"
#include "wx/confbase.h"
#include "wx/fileconf.h"
#include "wx/msw/regconf.h"


using namespace std;

bargraph::bargraph(wxFrame *frame, int iCol)
         : frame_bargraph(frame)
         {
             SetIcon(wxICON(APPICON));
             SetTitle(wxString::Format("Bar Graph Column %d", iCol));
         }
void bargraph::OnClose (wxCloseEvent& event) {
    Hide();
}

void bargraph::Update_all(int iCol, int *iRow, int Value_ADC[11][11])
{
    for(int i =0; i< *iRow; i++) bar[i]->SetValue(Value_ADC[i][iCol]);
}

bargraph::~bargraph()
{
}

valuetable::valuetable (wxFrame *frame)
           : frame_valuetable(frame)
           {
               SetIcon(wxICON(APPICON));
           }

void valuetable::OnClose (wxCloseEvent& event) {
    Hide();
}

void valuetable::Update_all(int *iCol,int *iRow,int *iCols,int *iRows, int Value_ADC[11][11])
{
    for(int row =*iRows-1; row< *iRow; row++)for(int col =*iCols-1; col< *iCol; col++)
            tf_ADC_[(row*10)+col+1]->SetValue(wxString::Format("%04i", Value_ADC[row][col]));
}

valuetable::~valuetable()
{
}

valuegrid::valuegrid (wxFrame *frame)
           : frame_valuegrid(frame)
           {
               SetIcon(wxICON(APPICON));
           }

void valuegrid::OnClose (wxCloseEvent& event) {
    Hide();
}

void valuegrid::Update_all(int *iCol,int *iRow,int *iCols,int *iRows, int Value_ADC[11][11])
{
    wxClientDC cdc(this);
    wxDC &dc = cdc ;
    wxBufferedDC bdc(&dc);
    bdc.SetPen( wxPen( wxT("yellow"), 3, wxSOLID) );
    bdc.SetBackground(wxBrush(wxColour(0,0,0)));
    bdc.Clear();


    for(int row =0; row< *iRow-*iRows+1; row++)
        for(int col =*iCols-1; col< *iCol; col++)
        {

         if (col<(*iCol-1)) bdc.DrawLine( 20+40*col+row*20, 500-(20*row+Value_ADC[*iRow-1-row][col]/4), 20+40*(col+1)+row*20, 500-(20*row+Value_ADC[*iRow-1-row][col+1]/4) );
         if (row<(*iRow-*iRows)) bdc.DrawLine( 20+40*col+row*20, 500-(20*row+Value_ADC[*iRow-1-row][col]/4), 20+40*(col)+(row+1)*20, 500-(20*(row+1)+Value_ADC[*iRow-1-row-1][col]/4) );

        }
}

valuegrid::~valuegrid()
{
}

 draw::draw(wxFrame *frame)
          : frame_draw(frame)
          {
              SetIcon(wxICON(APPICON));
              firsttouch=true;
          }


 void draw::OnClose (wxCloseEvent& event) {
     Hide();
 }

 void draw::Update_all(int *iCole,int *iRowe,int *iCols,int *iRows, int Value_ADC[11][11])
 {
     int col=0;
     int colmid=0;

     int weight=0;
     int vec_x=0;
     int vec_y=0;

     int weight2=0;
     int vec_x2=0;
     int vec_y2=0;


     int maxval1=0;
     int maxval2=0;
     int ROWMAX1=0;
     int COLMAX1=0;
     int ROWMAX2=0;
     int COLMAX2=0;

     int ROWM1=0;
     int COLM1=0;
     int ROWM2=0;
     int COLM2=0;

     int dRow=0;
     int dCol=0;
     int c_dep_axis=0;
     int row_depr=0;
     int weight_part=0;
     int weight_part2=0;



     int btouch=false;

     wxClientDC bdc2(this);
     //wxDC &dc2 = cdc2 ;
     //wxBufferedDC bdc2(&dc2);


     bdc2.SetPen( wxPen( wxT("black"), 4, wxSOLID) );
     bdc2.SetBrush(wxBrush(wxColour(0,0,0)));
     bdc2.SetBackground(wxBrush(wxColour(255,255,255)));
     bdc2.Clear();


    for(col =*iCols-1; col< *iCole; col++)
         for(int row =*iRows-1; row< *iRowe; row++){
             if (500-Value_ADC[row][col]>maxval1){
                 maxval1= 500-Value_ADC[row][col];
                 ROWMAX1=row;
                 COLMAX1=col;
             }
         }


    if (maxval1>40){
        btouch=true;
        for(col =*iCols-1; col< *iCole; col++)
         for(int row =*iRows-1; row< *iRowe; row++){

                    //wxLogDebug("row col val %02X %02X %d",row,col,Value_ADC[row][col]);

                 vec_x += (col * (500-Value_ADC[row][col]));//wxLogDebug("vec_x %d", vec_x);
                 vec_y += (row * (500-Value_ADC[row][col]));//wxLogDebug("vec_y %d", vec_y);
                 weight += (500-Value_ADC[row][col]);//wxLogDebug("weight %d", weight);


                 if ((col < COLMAX1-1) | (col > COLMAX1+1) | (row < ROWMAX1-1) | (row> ROWMAX1+1)){
                        if (500-Value_ADC[row][col]>maxval2){
                            maxval2= 500-Value_ADC[row][col];
                            COLMAX2= col;
                            ROWMAX2= row;
                        }
                 }

             }
    }

    if (maxval2>((maxval1*2)/4)){

        vec_x =0;
        vec_y =0;
        weight=0;

        COLM1=COLMAX1;
        ROWM1=ROWMAX1;
        if (COLMAX1==(*iCole-1)) COLM1 = COLMAX1-1;
        if (COLMAX1==(*iCols-1)) COLM1 = COLMAX1+1;
        if (ROWMAX1==(*iRowe-1)) ROWM1 = ROWMAX1-1;
        if (ROWMAX1==(*iRows-1)) ROWM1 = ROWMAX1+1;

        COLM2=COLMAX2;
        ROWM2=ROWMAX2;
        if (COLMAX2==(*iCole-1)) COLM2 = COLMAX2-1;
        if (COLMAX2==(*iCols-1)) COLM2 = COLMAX2+1;
        if (ROWMAX2==(*iRowe-1)) ROWM2 = ROWMAX2-1;
        if (ROWMAX2==(*iRows-1)) ROWM2 = ROWMAX2+1;



        for(col =COLM1-1; col< COLM1+2; col++)
         for(int row =ROWM1-1; row< ROWM1+2; row++){
                vec_x += (col * (500-Value_ADC[row][col]));//wxLogDebug("vec_x %d", vec_x);
                vec_y += (row * (500-Value_ADC[row][col]));//wxLogDebug("vec_y %d", vec_y);
                weight += (500-Value_ADC[row][col]);//wxLogDebug("weight %d", weight);
         }
        for(col =COLM2-1; col< COLM2+2; col++)
         for(int row =ROWM2-1; row< ROWM2+2; row++){
                vec_x2 += (col * (500-Value_ADC[row][col]));//wxLogDebug("vec_x %d", vec_x);
                vec_y2 += (row * (500-Value_ADC[row][col]));//wxLogDebug("vec_y %d", vec_y);
                weight2 += (500-Value_ADC[row][col]);//wxLogDebug("weight %d", weight);
         }

        vec_x *= 100;
        vec_y *= 100;
        vec_x /= weight;
        vec_y /= weight;

        vec_x2 *= 100;
        vec_y2 *= 100;
        vec_x2 /= weight2;
        vec_y2 /= weight2;

    //    bdc2.SetPen( wxPen( wxT("red"), 4, wxSOLID) );
        bdc2.DrawCircle( vec_x+10, vec_y+10, 20);
        bdc2.DrawCircle( vec_x2+10, vec_y2+10, 20);

        vec_x =0;
        vec_y =0;
        weight=0;

        vec_x2 =0;
        vec_y2 =0;
        weight2=0;

        bdc2.SetPen( wxPen( wxT("black"), 4, wxSOLID) );



//        dRow=ROWMAX2-ROWMAX1;
//        dCol=COLMAX2-COLMAX1;
//        if (dRow){
//            c_dep_axis= dRow*100/2 + ROWMAX1*100 + (dCol*dCol*100)/(2*dRow) + (dCol*COLMAX1*100)/dRow;
//          //  bdc2.DrawLine((*iCols-1)*100,c_dep_axis - dCol*(*iCols-1)*100/dRow,(*iCole-1)*100,c_dep_axis - dCol*(*iCole-1)*100/dRow);
//
//            for(col =*iCols-1; col< *iCole; col++){
//                row_depr= c_dep_axis - dCol*(col)*100/dRow;
//                for(int row =*iRows-1; row< *iRowe; row++){
//                     if ((row*100-50)<row_depr){
//                       vec_x += (col * (500-Value_ADC[row][col]));//wxLogDebug("vec_x %d", vec_x);
//                       vec_y += (row * (500-Value_ADC[row][col]));//wxLogDebug("vec_y %d", vec_y);
//                       weight += (500-Value_ADC[row][col]);//wxLogDebug("weight %d", weight);
//                     }
//                     else if ((row*100+50)>=row_depr){
//                       vec_x2 += (col * (500-Value_ADC[row][col]));//wxLogDebug("vec_x %d", vec_x);
//                       vec_y2 += (row * (500-Value_ADC[row][col]));//wxLogDebug("vec_y %d", vec_y);
//                       weight2 += (500-Value_ADC[row][col]);//wxLogDebug("weight %d", weight);
//                     }
//                     else{
//                       weight_part=(row_depr+50-row*100);
//                       weight_part2=100-weight_part;
//                       vec_x += (col * (500-Value_ADC[row][col])*weight_part/100);//wxLogDebug("vec_x %d", vec_x);
//                       vec_y += (row * (500-Value_ADC[row][col])*weight_part/100);//wxLogDebug("vec_y %d", vec_y);
//                       weight += (500-Value_ADC[row][col])*weight_part/100;//wxLogDebug("weight %d", weight);
//                       vec_x2 += (col * (500-Value_ADC[row][col])*weight_part2/100);//wxLogDebug("vec_x %d", vec_x);
//                       vec_y2 += (row * (500-Value_ADC[row][col])*weight_part2/100);//wxLogDebug("vec_y %d", vec_y);
//                       weight2 += (500-Value_ADC[row][col])*weight_part2/100;//wxLogDebug("weight %d", weight);
//                     }
//                }
//            }
//        }
//        else {
//            colmid=(dCol*100/2+COLMAX1*100);
//      //      bdc2.DrawLine(colmid,(*iRows-1)*100,colmid,(*iRowe-1)*100);
//
//            for(col =*iCols-1; col< colmid/100; col++)
//                for(int row =*iRows-1; row< *iRowe; row++){
//                       vec_x += (col * (500-Value_ADC[row][col]));//wxLogDebug("vec_x %d", vec_x);
//                       vec_y += (row * (500-Value_ADC[row][col]));//wxLogDebug("vec_y %d", vec_y);
//                       weight += (500-Value_ADC[row][col]);//wxLogDebug("weight %d", weight);
//                }
//
////            weight_part=((dCol*100/2+COLMAX1*100)+50-col*100);
////            weight_part2=100-weight_part;
////            for(int row =*iRows-1; row< *iRowe; row++){
////                       vec_x += (col * (500-Value_ADC[row][col])*weight_part/100);//wxLogDebug("vec_x %d", vec_x);
////                       vec_y += (row * (500-Value_ADC[row][col])*weight_part/100);//wxLogDebug("vec_y %d", vec_y);
////                       weight += (500-Value_ADC[row][col])*weight_part/100;//wxLogDebug("weight %d", weight);
////                       vec_x2 += (col * (500-Value_ADC[row][col])*weight_part2/100);//wxLogDebug("vec_x %d", vec_x);
////                       vec_y2 += (row * (500-Value_ADC[row][col])*weight_part2/100);//wxLogDebug("vec_y %d", vec_y);
////                       weight2 += (500-Value_ADC[row][col])*weight_part2/100;//wxLogDebug("weight %d", weight);
////            }
//
//            //col++;
//
//            for(col=col; col< *iCole; col++)
//                for(int row =*iRows-1; row< *iRowe; row++){
//                       vec_x2 += (col * (500-Value_ADC[row][col]));//wxLogDebug("vec_x %d", vec_x);
//                       vec_y2 += (row * (500-Value_ADC[row][col]));//wxLogDebug("vec_y %d", vec_y);
//                       weight2 += (500-Value_ADC[row][col]);//wxLogDebug("weight %d", weight);
//                }
//        }
//
//
//        vec_x *= 100;
//        vec_y *= 100;
//        vec_x /= weight;
//        vec_y /= weight;
//
//        vec_x2 *= 100;
//        vec_y2 *= 100;
//        vec_x2 /= weight2;
//        vec_y2 /= weight2;
//
//        bdc2.DrawCircle( vec_x+10, vec_y+10, 5);
//        bdc2.DrawCircle( vec_x2+10, vec_y2+10, 5);

    }




    else if (btouch == true){

     vec_x *= 100;
     vec_y *= 100;

     vec_x /= weight;
     vec_y /= weight;

     if (firsttouch==true){
         vec_x_filt=vec_x;
         vec_y_filt=vec_y;
         firsttouch=false;

     }
     vec_x_filt=(vec_x_filt*3+vec_x)/4;
     vec_y_filt=(vec_y_filt*3+vec_y)/4;


     bdc2.DrawCircle( vec_x+10, vec_y+10, 20);

    }
    else firsttouch = true;


 }

 void draw::Clear()
 {

     wxClientDC bdc2(this);
     //wxDC &dc2 = cdc2 ;
     //wxBufferedDC bdc2(&dc2);

     bdc2.SetPen( wxPen( wxT("black"), 5, wxSOLID) );
     bdc2.SetBrush(wxBrush(wxColour(0,0,0)));
     bdc2.SetBackground(wxBrush(wxColour(255,255,255)));
     bdc2.Clear();
 }

  draw::~draw()
  {



  }


calibpanel::calibpanel(wxFrame *frame)
    : frame_calib(frame)
{

    SetIcon(wxICON(APPICON));
    Selected_PE5004 = PE5004_SECOND;

    wxString strCaption;
    strCaption = (wxString) APPNAME + " " + APPVERS;
    SetTitle(strCaption);
    SetStatusBarPane(wxID_ANY);
    alt=0;
    sign =0;
    for(int i = 0; i < 10; i++) pbar[i] = new bargraph(this, i);
    for (int i=0;i<10;i++)for (int f=0;f<10;f++) empty[i][f]=0;
    pval = new valuetable(this);
    pgrid = new valuegrid(this);
    pdraw= new draw(this);
    pTimer = new wxTimer(this);
    usbDev = new CUSBDevice();
    usbDev->togglecurrent = 1;
    Connect(wxEVT_TIMER, wxCommandEventHandler(calibpanel::OnTimer));
    Update_all();
    grafzahl=0;
 	}

void calibpanel::OnHistory(wxCommandEvent &event) {
    CHistoryDialog *dialog = new CHistoryDialog(this);
    dialog->ShowModal();
    delete dialog;
}

void calibpanel::OnExit(wxCommandEvent &event) {
    Destroy();
}

void calibpanel::OnAbout(wxCommandEvent &event) {
    CAboutDialog *dialog = new CAboutDialog(this);
    dialog->ShowModal();
    delete dialog;
}




void calibpanel::OnTimer(wxCommandEvent &event)
{
    int HELPVAL;

    Update_all();
    READ5004();
    statusBar->SetStatusText(wxString::Format("%08i", grafzahl), 1);
    grafzahl++;
    if (grafzahl>99999999) grafzahl=0;
    UPDATE5004(!mode);
    //if (update==true) {UPDATE5004(!mode);update=false;}


    if (invert==false){
        for(int col =0; col< Value_COLEND; col++){
            for(int row =0; row< Value_ROWEND; row++){
                Value_admid[row][col]=(((Value_admid[row][col]*(filt-1))+Value_adreal[row][col])/filt);
                HELPVAL=(abs(Value_adcal[row][col]-Value_admid[row][col])-thresh);
                if (HELPVAL>0) Value_ADC[row][col]=((Value_admid[row][col]-Value_adcal[row][col])*stretch+Value_adcal[row][col]);
                else Value_ADC[row][col]=Value_adcal[row][col];
            }
            pbar[col]->Update_all(col, &Value_ROWEND, Value_ADC);
        }
    }
    else{
             for(int row =0; row< Value_ROWEND; row++){
                for(int col =0; col< Value_COLEND; col++){
                    HELPVAL=(500+Value_adreal[row][col]-Value_adcal[row][col]);
                    if (HELPVAL>(500+thresh)){
                        Value_admid[row][col]=(((Value_admid[row][col]*(filt-1))+((HELPVAL-500-thresh)*stretch+500))/filt);
                    }
                    else{
                        if (HELPVAL<(500-thresh)){
                        Value_admid[row][col]=(((Value_admid[row][col]*(filt-1))+(500-(500-HELPVAL+thresh)*stretch))/filt);
                        }
                        else{
                        Value_admid[row][col]=((Value_admid[row][col]+500)/2);
                        }
                    }
                    Value_ADC[row][col]=Value_admid[row][col];
                }
            }
        }


    for(int col =0; col< Value_COLEND; col++)pbar[col]->Update_all(col, &Value_ROWEND, Value_ADC);
    pgrid->Update_all(&Value_COLEND, &Value_ROWEND,&Value_COLSTART, &Value_ROWSTART, Value_ADC);
    pval->Update_all(&Value_COLEND, &Value_ROWEND,&Value_COLSTART, &Value_ROWSTART, Value_ADC);
    pdraw->Update_all(&Value_COLEND, &Value_ROWEND,&Value_COLSTART, &Value_ROWSTART, Value_ADC);

    if (mode != true)pTimer->Start(Value_updaterate, mode);
}


void calibpanel::Update_all()
{
        Value_COLSTART = ch_COLSTART->GetSelection()+1;
        Value_ROWSTART = ch_ROWSTART->GetSelection()+1;
        Value_COLEND = ch_COLEND->GetSelection()+1;
        Value_ROWEND = ch_ROWEND->GetSelection()+1;
        (tf_WaitCOL->GetValue()).ToLong((long*)&Value_WaitCOL,10);
        (tf_WaitROW->GetValue()).ToLong((long*)&Value_WaitROW,10);
        Value_PWRI = ch_PWRI->GetSelection();
        Value_SINF = sl_SINF->GetValue();
        Value_SINA = sl_SINA->GetValue();
        Value_PCO = sl_PCO->GetValue();
        Value_DACREF = sl_DACREF->GetValue();
        Value_GCO = sl_GCO->GetValue();
        Value_updaterate = sl_updaterate->GetValue();
        (tf_thresh->GetValue()).ToLong((long*)&thresh,10);
        (tf_stretch->GetValue()).ToLong((long*)&stretch,10);
        (tf_filt->GetValue()).ToLong((long*)&filt,10);
}


void calibpanel::On_OpenBargraph( wxCommandEvent& event )
{
      pbar[ch_bar->GetSelection()]->Show();
}

void calibpanel::On_OpenValuetable( wxCommandEvent& event )
{
      pval->Show();
}

void calibpanel::On_OpenValuegrid( wxCommandEvent& event )
{
      pgrid->Show();
}

void calibpanel::On_OpenDraw( wxCommandEvent& event )
{
      pdraw->Show();
      pdraw->Clear();
}




void calibpanel::On_Connect( wxCommandEvent& event )
{
    DWORD vendorID = VENDOR_ID;
    DWORD productID = PRODUCT_ID;
    DWORD versionNumber = VERSION_NB;

    //connect USB device
    if(usbDev->IsConnected) {
        usbDev->Disconnect();
        SetConnectStatus(false);
        mode=true;
        pTimer->Stop();
        statusBar->SetStatusText("stopped", 1);

    } else {

        usbDev->Connect(&vendorID,&productID,&versionNumber);
        if(usbDev->IsConnected) {
            SetConnectStatus(true);
        } else {
            SetConnectStatus(false);
        }
    }
}

void calibpanel::SetConnectStatus(bool bConnected) {

    if(bConnected) {
        mbFileConnect->Check(true);
        toolBar->ToggleTool(ID_TOOL_CONNECT, true);
        toolBar->SetToolNormalBitmap(ID_TOOL_CONNECT, wxIcon("ICO_CONNECT_ON", wxBITMAP_TYPE_ICO_RESOURCE, 32, 32));
        statusBar->SetStatusText("PE5004 Interface Board connected via USB", 0);
    } else {
        mbFileConnect->Check(false);
        toolBar->ToggleTool(ID_TOOL_CONNECT, false);
        toolBar->SetToolNormalBitmap(ID_TOOL_CONNECT, wxIcon("ICO_CONNECT_OFF", wxBITMAP_TYPE_ICO_RESOURCE, 32, 32));
        statusBar->SetStatusText("PE5004 Interface Board disconnected", 0);
    }
}

void calibpanel::On_Calib( wxCommandEvent& event )
{

    if(!usbDev->IsConnected) {
        wxMessageBox("Please connect PE5004 Interface Board !!!!", "alarm", wxICON_ERROR);
        return;
    }



    //write init values

    UPDATE5004(1);
    for(int row =0; row< Value_ROWEND; row++)for(int col =0; col< Value_COLEND; col++)Value_adcal[row][col]=1024;

    for (int k=0; k<20; k++){
        //write init values

        READ5004();

        if (k==0){ for(int row =0; row< Value_ROWEND; row++)for(int col =0; col< Value_COLEND; col++)
            Value_adcal[row][col]=Value_adreal[row][col];
        }
        else{
            for(int row =0; row< Value_ROWEND; row++)for(int col =0; col< Value_COLEND; col++)
                Value_adcal[row][col]=((Value_adcal[row][col]*5+Value_adreal[row][col])/6);

        }
    }
    invert=true;
    UPDATE5004(!mode);
}

void calibpanel::On_ClearCalib( wxCommandEvent& event )
{
     for(int row =0; row< Value_ROWEND; row++)for(int col =0; col< Value_COLEND; col++)
        {
            Value_adcal[row][col]=0;
        }
     invert=false;
}

void calibpanel::On_Preset( wxCommandEvent& event )
{
    // load file
    int iResult;

    wxFileDialog *dialog = new wxFileDialog(this, "Load Preset Data", ".", strFileNameGlobal, "*.txt", wxFD_OPEN);
    iResult = dialog->ShowModal();
    strFileNameGlobal = dialog->GetPath();
    delete dialog;

    wxFileConfig *config = new wxFileConfig("PE5004", "PE GmbH", strFileNameGlobal ,"", wxCONFIG_USE_LOCAL_FILE);

    config->Read("Value_COLSTART", &Value_COLSTART, 0);
    config->Read("Value_ROWSTART", &Value_ROWSTART, 0);
    config->Read("Value_COLEND", &Value_COLEND, 9);
    config->Read("Value_ROWEND", &Value_ROWEND, 9);
    config->Read("Value_SINF", &Value_SINF, 7);
    config->Read("Value_SINA", &Value_SINA, 63);
    config->Read("Value_PCO", &Value_PCO, 151);
    config->Read("Value_DACREF", &Value_DACREF, 2);
    config->Read("Value_GCO", &Value_GCO, 2);
    config->Read("thresh", &thresh, 0);
    config->Read("stretch", &stretch, 1);
    config->Read("filt", &filt, 1);
    config->Read("paddle", &boxmode_game, false);
    config->Read("calibrate", &calibrate, false);
    config->Read("OpenWindow", &openw, 0);
    config->Read("Autoconnect", &autoconnect, false);
    delete config;

    ch_COLSTART->SetSelection(Value_COLSTART-1);
    ch_ROWSTART->SetSelection(Value_ROWSTART-1);
    ch_COLEND->SetSelection(Value_COLEND-1);
    ch_ROWEND->SetSelection(Value_ROWEND-1);

    tf_SINF->SetValue(wxString::Format("%i", Value_SINF));
    tf_SINA->SetValue(wxString::Format("%i", Value_SINA));
    tf_PCO->SetValue(wxString::Format("%i", Value_PCO));
    tf_DACREF->SetValue(wxString::Format("%i", Value_DACREF));
    tf_GCO->SetValue(wxString::Format("%i", Value_GCO));
    tf_thresh->SetValue(wxString::Format("%i", thresh));
    tf_stretch->SetValue(wxString::Format("%i", stretch));
    tf_filt->SetValue(wxString::Format("%i", filt));

    sl_SINF->SetValue(Value_SINF);
    sl_SINA->SetValue(Value_SINA);
    sl_PCO->SetValue(Value_PCO);
    sl_DACREF->SetValue(Value_DACREF);
    sl_GCO->SetValue(Value_GCO);
    //cb_multimode->SetValue(multimode);
    if (autoconnect) if(!(usbDev->IsConnected)) On_Connect(blankevent);
    Update_all();
    Sleep(100);
    if (calibrate)On_Calib(blankevent);
    switch(openw){
        case 1: {pval->Show();On_Continous(blankevent);break;}
        case 2: {pgrid->Show();On_Continous(blankevent);break;}
        default: break;
    }
}




void calibpanel::On_Save( wxCommandEvent& event )
{
    // load file
    int iResult;
    wxString strFileName;
    wxFile outFile;

    strFileName = wxDateTime::Now().Format("ConfigurationData_%Y%m%d_%H%M%S.txt");

    wxFileDialog *dialog = new wxFileDialog(this, "Save Configuration Data", ".", strFileName, "*.txt", wxFD_SAVE);
    iResult = dialog->ShowModal();
    strFileName = dialog->GetPath();
    strFileNameGlobal = strFileName;
    delete dialog;

    if(iResult == wxID_OK) {
        if(outFile.Exists(strFileName)) {
            iResult = wxMessageBox("File already exists. Overwrite file:\n" + strFileName, "Save Configuration Data", wxYES_NO | wxICON_QUESTION);
            if(iResult == wxYES) {
                if(!outFile.Access(strFileName, wxFile::write)) {
                    wxMessageBox("Could not write file:\n" + strFileName, "Save Configuration Data", wxOK | wxICON_ERROR);
                    return;
                }
            } else {
                return;
            }
        }
    } else {
        return;
    }

    Update_all();

    wxFileConfig *config = new wxFileConfig("PE5004", "PE GmbH", strFileName ,"", wxCONFIG_USE_LOCAL_FILE);

    config->Write("Value_COLSTART", Value_COLSTART);
    config->Write("Value_ROWSTART", Value_ROWSTART);
    config->Write("Value_COLEND", Value_COLEND);
    config->Write("Value_ROWEND", Value_ROWEND);
    config->Write("Value_SINF", Value_SINF);
    config->Write("Value_SINA", Value_SINA);
    config->Write("Value_PCO", Value_PCO);
    config->Write("Value_DACREF", Value_DACREF);
    config->Write("Value_GCO", Value_GCO);
    config->Write("thresh", thresh);
    config->Write("stretch", stretch);
    config->Write("filt", filt);
    config->Write("paddle", boxmode_game);

    delete config;
}

void calibpanel::Scroll_calib( wxScrollEvent& event )
{
    switch(event.GetId())
    {
        case SINF:
        {
            Value_SINF = sl_SINF->GetValue();
            tf_SINF->SetValue(wxString::Format("%i", Value_SINF));
            update=true;
            break;
        }
        case SINA:
        {
            Value_SINA = sl_SINA->GetValue();
            tf_SINA->SetValue(wxString::Format("%i", Value_SINA));
            update=true;
            break;
        }
        case PCO:
        {
            Value_PCO = sl_PCO->GetValue();
            tf_PCO->SetValue(wxString::Format("%i", Value_PCO));
            update=true;
            break;
        }
         case DACREF:
        {
            Value_DACREF = sl_DACREF->GetValue();
            tf_DACREF->SetValue(wxString::Format("%i", Value_DACREF));
            update=true;
            break;
        }
        case GCO:
        {
            Value_GCO = sl_GCO->GetValue();
            tf_GCO->SetValue(wxString::Format("%i", Value_GCO));
            update=true;
            break;
        }
        case updaterate:
        {
            Value_updaterate = sl_updaterate->GetValue();
            tf_updaterate->SetValue(wxString::Format("%i", Value_updaterate));
            Update_all();
        }
    }

}

void calibpanel::Text_calib( wxCommandEvent& event )
{
    switch(event.GetId())
    {
        case SINF:
        {
            (tf_SINF->GetValue()).ToLong((long*)&Value_SINF,10);
             sl_SINF->SetValue(Value_SINF);
             update=true;
             break;
        }
        case SINA:
        {
            (tf_SINA->GetValue()).ToLong((long*)&Value_SINA,10);
             sl_SINA->SetValue(Value_SINA);
             update=true;
             break;
        }
        case PCO:
        {
            (tf_PCO->GetValue()).ToLong((long*)&Value_PCO,10);
             sl_PCO->SetValue(Value_PCO);
             update=true;
             break;
        }
        case DACREF:
        {
            (tf_DACREF->GetValue()).ToLong((long*)&Value_DACREF,10);
             sl_DACREF->SetValue(Value_DACREF);
             update=true;
             break;
        }
        case GCO:
        {
            (tf_GCO->GetValue()).ToLong((long*)&Value_GCO,10);
             sl_GCO->SetValue(Value_GCO);
             update=true;
             break;
        }
        case updaterate:
        {
            (tf_updaterate->GetValue()).ToLong((long*)&Value_updaterate,10);
             sl_updaterate->SetValue(Value_updaterate);
             Update_all();
             break;
        }
         case idClick:
        {
            update=true;
        }
    }
}

void calibpanel::Choice_calib( wxCommandEvent& event )
{
    update=true;
    int e=10;
    int s=1;
    pval->Update_all(&e, &e,&s, &s, empty);
}

void calibpanel::On_SingleShot( wxCommandEvent& event )
{
    if(!usbDev->IsConnected) {
        wxMessageBox("Please connect PE5004 Interface Board !!!!", "alarm", wxICON_ERROR);
        return;
    }
    UPDATE5004(1);

    mode=true;

   pTimer->Start(Value_updaterate, mode);
}

void calibpanel::On_Continous( wxCommandEvent& event )
{
    if(!usbDev->IsConnected) {
        wxMessageBox("Please connect PE5004 Interface Board !!!!", "alarm", wxICON_ERROR);
        return;
    }
    UPDATE5004(1);

    mode=false;

    pTimer->Start(Value_updaterate, mode);//Value_updaterate

}

void calibpanel::On_Stop( wxCommandEvent& event )
{

    UPDATE5004(0);
    mode=true;
    pTimer->Stop();
    statusBar->SetStatusText("stopped", 1);
}


void calibpanel::UPDATE5004(bool start){

    DWORD error;
    Update_all();
    HID_IN8[0]=0;

    HID_IN8[1]=0x02;
    HID_IN8[2]=Value_WaitCOL>>4;
    HID_IN8[3]=((Value_WaitCOL<<4)| (Value_WaitROW>>8));
    HID_IN8[4]=Value_WaitROW;

    HID_IN8[5]=0x03;
    HID_IN8[6]=((Value_SINF<<2)|(Value_SINA>>4));
    HID_IN8[7]=((Value_SINA<<4)|(Value_PWRI<<3));
    HID_IN8[8]=((Value_GCO<<4)|(Value_DACREF));

    HID_IN8[9]=0x04;
    HID_IN8[10]=0x00;
    HID_IN8[11]=Value_PCO>>8;
    HID_IN8[12]=Value_PCO;

    HID_IN8[13]=0x01;
    HID_IN8[14]=(Value_COLSTART-1);
    HID_IN8[15]=(((Value_ROWSTART-1)<<4)|(Value_COLEND-1));
    HID_IN8[16]=(((Value_ROWEND-1)<<4)|start);

    error=usbDev->Write(HID_IN8, USB_WRBYTELENGTH);
    if (error==1167)On_Connect(blankevent);
}

void calibpanel::READ5004(){
        DWORD error;
        int c;
        int r;
        int i=2;
        int pack=0;
        int USB_NB=0;

        HID_OUT8[0][1]=0x80;
        while (HID_OUT8[0][1]&0x80) {error=usbDev-> Read(HID_OUT8[0], USB_BYTELENGTH);if (error==1167)On_Connect(blankevent);}
        if (((Value_ROWEND-Value_ROWSTART+1)*(Value_COLEND-Value_COLSTART+1))>48){ error=usbDev-> Read(HID_OUT8[1], USB_BYTELENGTH);if (error==1167)On_Connect(blankevent);}
        if (((Value_ROWEND-Value_ROWSTART+1)*(Value_COLEND-Value_COLSTART+1))>96){ error=usbDev-> Read(HID_OUT8[2], USB_BYTELENGTH);if (error==1167)On_Connect(blankevent);}

        for (c=(Value_COLEND-1);c>=Value_COLSTART-1;c--){
            for (r=(Value_ROWSTART-1);r<Value_ROWEND;r++){
                Value_adreal[r][c]=((HID_OUT8[USB_NB][i]) | ( (HID_OUT8[USB_NB][i+(4-(pack>>1))]&(3<<pack))<<(8-pack) ))  ;
                pack +=2;
                if (pack>6) {pack=0;i++;}
                i++;
                if (i>61){
                    i=2;
                    USB_NB++;
                }
            }
        }

}





calibpanel::~calibpanel()
{
    Disconnect(wxEVT_TIMER, wxCommandEventHandler(calibpanel::OnTimer));
    wxDELETE(pTimer);
}


