/***************************************************************
 * Name:    wxDialogs.cpp
 * Purpose: classes for gui dialogs
 * Author:  Joerg Eichler
 * Created: 04-2009
 **************************************************************/

#include "wxDialogs.h"
#include "version.h"

CHistoryDialog::CHistoryDialog(wxWindow *parent)
               :wxHistoryDialog(parent) {
    SetIcon(wxICON(APPICON));
    writeHistory(txtHistory);
}

CHistoryDialog::~CHistoryDialog() {
}

void CHistoryDialog::OnOK(wxCommandEvent &event) {
    SetReturnCode(wxID_OK);
    Destroy();
}

void CHistoryDialog::OnClose(wxCloseEvent &event) {
    SetReturnCode(wxID_CLOSE);
    Destroy();
}

CAboutDialog::CAboutDialog(wxWindow *parent)
             :wxAboutDialog(parent) {
    SetIcon(wxICON(APPICON));

    wxString strCaption;
    strCaption = (wxString) APPNAME;
    txtName->SetLabel(strCaption);
    strCaption = (wxString) "Version " + APPVERS;
    txtVersion->SetLabel(strCaption);
}

CAboutDialog::~CAboutDialog() {
}

void CAboutDialog::OnLogo(wxMouseEvent &event) {
    wxLaunchDefaultBrowser(lnkURL->GetURL());
}

void CAboutDialog::OnAuthor(wxMouseEvent &event) {
}

void CAboutDialog::OnOK(wxCommandEvent &event) {
    SetReturnCode(wxID_OK);
    Destroy();
}

void CAboutDialog::OnClose(wxCloseEvent &event) {
    SetReturnCode(wxID_CLOSE);
    Destroy();
}
